/***************************************************************/
/*                                                             */
/*                 test_2.c                                    */
/*                                                             */
/***************************************************************/


#include <stdio.h>
#include <math.h>

typedef struct point POINT;
struct point
{
  double x;
  double y;
};

struct triangle
{
  struct  point   pt0;
  struct  point   pt1;
  struct  point   pt2;
};

void print_point(char *name, struct point p)
{
  printf("%s = (%1f, %1f)\n", name, p.x, p.y);
}

struct point barycenter(struct triangle t)
{
  t.pt0.x += t.pt1.x +t.pt2.x;
  t.pt0.x *=1.0/3.0;
  t.pt0.y += t.pt1.y +t.pt2.y;
  t.pt0.y *=1.0/3.0;

  return(t.pt0);
}

void print_trinangle(char *name, struct triangle t)
{
  char namept[128];

  sprintf(namept, "%s.p0", name);
  print_point(namept, t.pt0);
  sprintf(namept, "%s.p1", name);
  print_point(namept, t.pt1);
  sprintf(namept, "%s.p2", name);
  print_point(namept, t.pt2);
}

int main(void)
{
  struct triangle t = {{0.0, 0.0}, {1.0, 0.0}, {0.0, 1.0}};

  print_trinangle("triangle", t);
  print_point("barycenter", barycenter(t));
  print_trinangle("triangle", t);

  return(0);
}
