/***************************************************************/
/*                                                             */
/*                 test_3.c                                    */
/*                                                             */
/***************************************************************/


#include <stdio.h>
#include <math.h>

typedef struct point POINT;
struct point
{
  double x;
  double y;
};

struct triangle
{
  struct  point   pt0;
  struct  point   pt1;
  struct  point   pt2;
};

struct point set_point(double x, double y)
{
  struct point temp;

  temp.x = x;
  temp.y = y;
  return(temp);
}

void print_point(char *name, struct point *p)
{
  printf("%s = (%1f, %1f)\n", name, p->x, p->y);
  /* <=> printf("%s = (%1f, %1f)\n", name, (*p).x, (*p).y);*/
}

void print_point_better(const char *name, struct point *p)
{
  printf("%s = (%1f, %1f)\n", name, p->x, p->y);
}

double dist_wrong(struct point *p1, struct point *p2)
{
  (*p1).x -=(*p2).x;
  p1->y -=p2->y;
  print_point("p1 in dist", p1);

  return(sqrt(p1->x*p1->x+p1->y*p1->y));
}

double dist_right(struct point *p1, struct point *p2)
{
  struct point p;
  p.x=p1->x -p2->x;
  p.y=p1->y -p2->y;

  return(sqrt(p.x*p.x+p.y*p.y));
}

double dist_better(const struct point *p1, const struct point *p2)
{
  struct point p;
  p.x=p1->x -p2->x;
  p.y=p1->y -p2->y;

  return(sqrt(p.x*p.x+p.y*p.y));
}

int main(void)
{
  struct point p1 = {0.0, 2.0}, p2;

  p2 = set_point(1.0, 1.0);

  print_point("p1", &p1);
  print_point("p2", &p2);
  printf("dist(p1,p2) = %1f\n", dist_wrong(&p1, &p2));
  print_point("p1", &p1);
  print_point("p2", &p2);
  p1 = set_point(0.0, 2.0);
  printf("dist(p1,p2) = %1f\n", dist_right(&p1, &p2));
  print_point("p1", &p1);
  print_point("p2", &p2);

  return(0);
}
