/***************************************************************/
/*                                                             */
/*                 test_4.c                                    */
/*                                                             */
/***************************************************************/

#include <stdio.h>
#include <math.h>

typedef struct point POINT;
struct point
{
  double x;
  double y;
};

struct triangle
{
  struct  point   pt0;
  struct  point   pt1;
  struct  point   pt2;
};

struct point set_point(double x, double y)
{
  struct point temp;

  temp.x = x;
  temp.y = y;
  return(temp);
}

void print_point(char *name, struct point *p)
{
  printf("%s = (%1f, %1f)\n", name, p->x, p->y);
}

void print_point_better(const char *name, struct point *p)
{
  printf("%s = (%1f, %1f)\n", name, p->x, p->y);
}

struct point barycenter(const struct triangle *t)
{
  struct point p;
  p.x = 1.0/3.0*(t->pt0.x + t->pt1.x +t->pt2.x);
  p.y = 1.0/3.0*(t->pt0.y + t->pt1.y +t->pt2.y);

  return(p);
}

void print_trinangle(const char *name, const struct triangle *t)
{
  char namept[128];

  sprintf(namept, "%s.p0", name);
  print_point_better(namept, &t->pt0);
  sprintf(namept, "%s.p1", name);
  print_point_better(namept, &t->pt1);
  sprintf(namept, "%s.p2", name);
  print_point_better(namept, &t->pt2);
}

int main(void)
{
  struct triangle t = {{0.0, 0.0}, {1.0, 0.0}, {0.0, 1.0}};
  struct triangle *pt;
  struct point    b, *pb = &b;

  pt = &t;
  print_trinangle("triangle", pt);
  b = barycenter(pt);
  print_point("barycenter", pb);
  print_trinangle("triangle", pt);

  return(0);
}
