/***************************************************************/
/*                                                             */
/*                 test_5.c                                    */
/*                                                             */
/***************************************************************/

#include <stdio.h>
#include <math.h>

typedef struct point POINT;
struct point
{
  double x;
  double y;
};

struct triangle
{
  struct  point   pt[3];
};

struct point set_point(double x, double y)
{
  struct point temp;

  temp.x = x;
  temp.y = y;
  return(temp);
}

void print_point(char *name, struct point *p)
{
  printf("%s = (%1f, %1f)\n", name, p->x, p->y);
}

double dist_right(struct point *p1, struct point *p2)
{
  struct point p;
  p.x=p1->x -p2->x;
  p.y=p1->y -p2->y;

  return(sqrt(p.x*p.x+p.y*p.y));
}

struct point barycenter(const struct triangle *t)
{
  struct point p = {0.0, 0.0};
  int          i;

  for (i=0 ; i<3 ; i++)
    {
      p.x += t->pt[i].x;
      p.y += t->pt[i].y;
    }

  p.x /= 3.0;
  p.y /= 3.0;
 
  return(p);
}

void print_trinangle(const char *name, const struct triangle *t)
{
  char namept[128];
  int          i;

  for (i=0 ; i<3 ; i++)
    {
      sprintf(namept, "%s.p%d", name, i);
      print_point(namept, t->pt+i);

      /*<=> print_point(namept, &t->pt[i]);*/
    }
}

int main(void)
{
  struct triangle t = {{{0.0, 0.0}, {1.0, 0.0}, {0.0, 1.0}}};
  struct triangle *pt;
  struct point    b, *pb = &b;

  pt = &t;
  print_trinangle("triangle", pt);
  b = barycenter(pt);
  print_point("barycenter", pb);
  print_trinangle("triangle", pt);

  return(0);
}
